import os
import argparse
from Bio import AlignIO
import re


def find_tree_path(output_dir):
    files = os.listdir(output_dir)
    for file in files:
        if "_phyml_tree_" in file:
            full_file_path = os.path.join(output_dir, file)
            os.rename(full_file_path, os.path.join(output_dir, "phyML_tree.newick"))
            return os.path.join(output_dir, "phyML_tree.newick")
    return None

def convert_alignment_format(output_dir):
    mafft_alignment = os.path.join(output_dir, "mafft_msa.clustal")
    new_mafft_alignment_path = os.path.join(output_dir, "msa_mafft.phy")
    AlignIO.convert(mafft_alignment, "clustal", new_mafft_alignment_path, "phylip-sequential")
    return





if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="counts some statistics")
    parser.add_argument("--output", "-o", help = "output directory")
    parser.add_argument("--alignment", "-a", type = int, help = "use alignment function")


    args = parser.parse_args()
    output = args.output
    msa_bool = args.alignment
    if not msa_bool:

        find_tree_path(output)
    else:
        convert_alignment_format(output)


