import os
import argparse
import re
from ete3 import Tree

## takes as an argument tree and adds zero length branch to the root: (((sp1:0.1, sp2:0.5)nd2:0.1), sp8:0.8)nd1; -> (((sp1:0.1, sp2:0.5)nd2:0.1), sp8:0.8)nd1:0;
def edit_tree(tree_path):
    file = open(tree_path,'r')
    patern_tree_no_spaces = re.compile("[\S]+")
    tree = file.read()
    file.close()
    root_pattern = re.compile("nd[\d]+(;)")
    p_to_replace =  root_pattern.findall(tree)
    if p_to_replace == []:
        return patern_tree_no_spaces.findall(tree)[0]
    str_to_replace = p_to_replace[0]
    edited_tree = re.sub(str_to_replace, ":0;", tree)
    return patern_tree_no_spaces.findall(edited_tree)[0]

# infile for PATHd8- considering only the root.
def create_control_pathd8(number_of_sites, tree_depth, dir_for_output, phyml):
    tree_name = ""
    if phyml:
        tree_name = "phyML_"
    file_path_of_mrca = os.path.join(dir_for_output, tree_name+"mrca_treepl.txt")
    tree_path = os.path.join(dir_for_output, tree_name+"tree.newick")

    new_tree = edit_tree(tree_path)
    content = ""
    content += ("Sequence length = "+ str(number_of_sites) +";\n\n")
    content += (new_tree +"\n")
    t = Tree(new_tree, format = 1)
    print(t)
    file_mrca = open(file_path_of_mrca, 'r')
    mrca_data = file_mrca.read()
    file_mrca.close()
    p = re.compile("([\S]+)")
    names_of_leaves = p.findall(mrca_data)

    content += ("mrca: "+ names_of_leaves[1] + ", " + names_of_leaves[2] + ", fixage="+str(tree_depth)+";\n")
    if not phyml:
        content += ("name of mrca: "+ names_of_leaves[1] + ", "+ names_of_leaves[2]+ ", name="+ t.name+";\n")
    path_for_control = os.path.join(dir_for_output, tree_name+"control_pathd8.txt")
    file = open(path_for_control, 'w')
    file.write(content)
    file.close()


if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="creates treePL control files")
    parser.add_argument("--output", "-o", help = "output directory")
    parser.add_argument("--sites", "-s", help = "number of sites")
    parser.add_argument("--depth", "-d", help = "depth of tree")
    parser.add_argument("--phyml", "-p", type = int, help = "phyml tree")

    args = parser.parse_args()
    output_dir = args.output
    sites = args.sites
    depth = args.depth
    phyml = args.phyml

    create_control_pathd8(sites, depth, output_dir, phyml)











