import os
import argparse
from subprocess import Popen
from create_job_scripts import create_job_format_for_all_jobs



def getFinalTree(output_dir, list_of_r, tree_sizes, phyML, dir_of_scripts):

    #list_of_r = os.listdir(output_dir)
    for r in list_of_r:
        full_r_dir = os.path.join(output_dir, str(r))
        if not os.path.isdir(full_r_dir):
            continue
        for tree_size in tree_sizes:
            full_tree_size = os.path.join(full_r_dir, str(tree_size))
            list_of_trees = os.listdir(full_tree_size)
            for tree_replicate in list_of_trees:
                full_tree_rep_dir = os.path.join(full_tree_size, tree_replicate)
                if phyML == 0:
                    output_file_path = os.path.join(full_tree_rep_dir, "pathd8_output.txt")
                else:
                    output_file_path = os.path.join(full_tree_rep_dir, "phyML_pathd8_output.txt")
                if not os.path.exists(output_file_path):
                    print("does not exist file : "+ output_file_path+"\n")

                    continue


                job = create_job_for_tree_creation(full_tree_rep_dir, output_file_path, phyML, dir_of_scripts)

                Popen(["qsub", job])
                #Popen(["qsub", job])

                # reate_configure_file(output_dir, configure_file_path, tree_file_path, mrca_file_path, num_of_sites, minimum, maximum, python_file_cmd)
    return

def create_job_for_tree_creation(full_tree_rep_dir, output_file_path, phyML, dir_of_scripts):
    python_script = os.path.join(dir_of_scripts, "get_tree_from_output_pathd8.py")
    if phyML:
        path_of_job = os.path.join(full_tree_rep_dir, "create_tree1.sh")
    else:
        path_of_job = os.path.join(full_tree_rep_dir, "create_tree0.sh")
    if phyML:
        cmd = "python " + python_script + " -o " + full_tree_rep_dir + " -f " + output_file_path + " -p 1" + "\n"
    else:
        cmd = "python "+ python_script+ " -o "+full_tree_rep_dir+" -f "+ output_file_path+ " -p 0"+"\n"
    jobName = "py_script"
    if phyML:
        jobName = "py_script1"

    headers = create_job_format_for_all_jobs(full_tree_rep_dir, jobName)
    file = open(path_of_job, 'w')
    file.write(headers)
    file.write("module load python/anaconda_python-3.5\n")
    file.write("cd " + full_tree_rep_dir + "\n")
    file.write(cmd)
    file.close()


    return path_of_job


if __name__ == '__main__':
    parser = argparse.ArgumentParser(description="creates tree from pathd8 output")
    parser.add_argument("--output", "-o", help = "output directory")
    parser.add_argument("--tree_sizes", "-t", type = int, nargs = '+', help = "list of tree sizes")
    parser.add_argument("--rates_ratio", "-r", type = float, nargs = '+', help = "r")
    parser.add_argument("--dir_of_scripts", "-d", help = "specify the directory where the scripts are located")
    parser.add_argument("--phyML", "-p", type = int, help = "specify if the tree is inferred by PhyML")



    args = parser.parse_args()
    output_dir = args.output
    taxa_list = args.tree_sizes
    r_list = args.rates_ratio
    dir_of_scripts = args.dir_of_scripts
    phyML = args.phyML



    getFinalTree(output_dir, r_list, taxa_list, phyML, dir_of_scripts)