import argparse
import re
import os


def get_tree_and_save(output_path, output_directory, phyml):
    dict_names = {0: "", 1:"phyML_"}
    tree_pattern = re.compile("(\(.*?;)")
    output_file = open(output_path, 'r')
    content = output_file.read()
    output_file.close()
    trees = tree_pattern.findall(content)
    calibrated_tree = trees[0]
    path_for_calibrated_tree = os.path.join(output_directory, dict_names[phyml] + "dated_tree_pathd8.newick")
    file = open(path_for_calibrated_tree, 'w')
    file.write(calibrated_tree+"\n")
    file.close()


if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="creates treePL control files")
    parser.add_argument("--output", "-o", help = "tree path")
    parser.add_argument("--file_res", "-f", help = "result file")
    parser.add_argument("--phyml", "-p", type = int, help = "phyml tree")

    args = parser.parse_args()
    output = args.output
    file_res = args.file_res
    phyml = args.phyml

    get_tree_and_save(file_res, output, phyml)

