import re
import os
import argparse


def relace_sequence_in_sequential_msa(file_path):
    file = open(file_path, 'r')
    msa = file.read()
    file.close()
    p = re.compile("\*s1.*")
    outgroup = p.findall(msa)[0]
    p_to_replace = re.compile("s.*")
    all_taxa_seqs = p_to_replace.findall(msa)
    species_to_switch = all_taxa_seqs[-1]
    msa_temp = re.sub(species_to_switch, outgroup, msa)
    final_msa = re.sub("\*s.*", species_to_switch, msa_temp, count = 1)
    went_ok = test(msa, final_msa)
    if not went_ok:
        print("NEED TO BE FIXED!!!!")
    file = open(file_path, 'w')
    file.write(final_msa)
    file.close()

def test(msa, final_msa):
    sp = re.compile("[\S]*s[\S]+")
    p_to_replace = re.compile("s.*")
    all_taxa_seqs_original = p_to_replace.findall(msa)
    all_taxa_seqs_modified = p_to_replace.findall(final_msa)
    species_original = set([sp.findall(all_taxa_seqs_original[i])[0] for i in range(len(all_taxa_seqs_original))])
    species_modified = set([sp.findall(all_taxa_seqs_modified[i])[0] for i in range(len(all_taxa_seqs_modified))])
    return (species_original == species_modified)


if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="convert")
    parser.add_argument("--output", "-o", help = "output directory")




    args = parser.parse_args()
    output = args.output
    relace_sequence_in_sequential_msa(output)










