library(ape)

####################################################################

scale_depth <- function(tree, new_depth){
  current_depth <- get_depth_of_tree(tree)
  ratio <- new_depth/current_depth
  branch_lengths <- tree$edge.length
  for (i in 1:length(branch_lengths)){
    tree$edge.length[i] <- branch_lengths[i] * ratio
    
  }
  print("Rescaled Depth!!!\n")
  return (tree)
  
}
#####################################################################

# finds the descendants which are the tips in the tree, and returns their label
find_tips_among_descendants <- function(tree, descendants_of_node, number_of_taxa){
  tip_indices <- descendants_of_node[descendants_of_node <= number_of_taxa]
  return(tree$tip.label[tip_indices])
  
}

#################################################################################################################

get_depth_of_tree <- function(phy){
  number_of_tips <- length(phy$tip.label)
  depths_of_nodes <- node.depth.edgelength(phy) # getting depth for each node. Here the depth function considers the root depth as 0.
  depths_of_tips <- depths_of_nodes[1:number_of_tips]
  return (max(depths_of_tips))
  
}